// BitmapBuffer.cpp: implementation of the CBitmapBuffer class.
//
// .          
//      
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BitmapBuffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


//-------------------------------------
// :
//{
// DIB- pDIBbuff[ymax_in][xmax_in]
//lenOfBufToCheck 
#define def_MakeDIB_beg(pDIBbuff,lenOfBufToCheck,xmax_in,ymax_in,actIfErr) \
			{\
				DWORD x,y;\
				DWORD xmax=(xmax_in);\
				DWORD ymax=(ymax_in);\
				const DWORD* pdwd=0;\
				if(!(pDIBbuff))actIfErr;\
				if((lenOfBufToCheck)!=xmax*ymax*3+(xmax%4*ymax))actIfErr;\
				for(y=0;y<ymax;y++)\
				{\
					for(x=0;x<xmax;x++)\
					{\
						;
		//-------------------------------------
						// :  dwd == func(x,y);
		//-------------------------------------

#define def_MakeDIB_end(pDIBbuff,DWORD_in) \
						pdwd=&(DWORD_in);\
						*(pDIBbuff)=*(2+(BYTE*)pdwd); (pDIBbuff)++;\
						*(pDIBbuff)=*(1+(BYTE*)pdwd); (pDIBbuff)++;\
						*(pDIBbuff)=*(0+(BYTE*)pdwd); (pDIBbuff)++;\
					}\
					/*  4*/\
					(pDIBbuff)+=(x%4);\
				}\
			}
//}
//-------------------------------------




CBitmapBuffer::CBitmapBuffer()
{
	Clear();
}

CBitmapBuffer::~CBitmapBuffer()
{
	Clear();
}

//
//bDontTouchModeAndParentPointer -       
void CBitmapBuffer::Clear(bool bDontTouchModeAndParentPointer)
{
	m_Params.Clear();

	if(!bDontTouchModeAndParentPointer)
	{
		m_Mode=e_0;
		m_pRGBparent=0;
	}
}

//      ,  
bool CBitmapBuffer::SetMode(ee_mode mode_in,CBitmapBuffer* pParentWatcher)
{
	m_Mode=e_0;
	m_pRGBparent=0;

	if(m_Params.SetMode(mode_in,pParentWatcher))
	{
		m_Mode=mode_in;
		m_pRGBparent=pParentWatcher;
		return true;
	}

	return false;
}

// m_pRGB  
//ldcW,ldcH -       
//xScrollShift,yScrollShift -     (  )
void CBitmapBuffer::Paint_OnDc(CDC &dc, long ldcW, long ldcH,long xScrollShift,long yScrollShift)
{
	DWORD x0=0;//   
	DWORD y0=0;//	(  )

	//  DIB  -
	#define def_OutDIBtoScreen \
			BITMAPINFO bmpinfohdr;\
			bmpinfohdr.bmiHeader=m_Params.m_LastUsedBITMAPINFOHEADER;\
			StretchDIBits(\
				dc.m_hDC,\
				x0,y0,\
				m_Params.Get_m_dwdX(),m_Params.Get_m_dwdY(),\
				xScrollShift,-yScrollShift,\
				m_Params.Get_m_dwdX(),m_Params.Get_m_dwdY(),\
				m_Params.Get_m_TempBuferToMakeDIB(),&bmpinfohdr,\
				DIB_RGB_COLORS,SRCCOPY)


	switch(m_Mode)
	{
		//  ( )
		case e_RGB_parent:
		{
			if(m_pRGBparent)break;

			//m_Params
			if(!m_Params.CheckCorrectForParentBody())break;

			// DIB
			BYTE* pDIB=m_Params.ZeroAndThenGetPointer_m_TempBuferToMakeDIB();
			def_MakeDIB_beg(pDIB,m_Params.Get_m_LastUsedBitzDataLen(),m_Params.Get_m_dwdX(),m_Params.Get_m_dwdY(),break);
			def_MakeDIB_end(pDIB,m_Params.Get_m_pRGBpixel(x,y,true)->RGBnew);
			def_OutDIBtoScreen;// DIB  
		}
		break;

		case e_Y_child:
		{
			if(!m_pRGBparent)break;

			s_ParentsOnlyParams& m_Params=m_pRGBparent->m_Params;//   
			if(!m_Params.CheckCorrectForParentBody())break;// 

			// DIB
			BYTE* pDIB=m_Params.ZeroAndThenGetPointer_m_TempBuferToMakeDIB();
			def_MakeDIB_beg(pDIB,m_Params.Get_m_LastUsedBitzDataLen(),m_Params.Get_m_dwdX(),m_Params.Get_m_dwdY(),break);
			def_MakeDIB_end(pDIB,m_Params.Get_m_pYpixel(x,y,true)->RGBpixel);
			def_OutDIBtoScreen;// DIB  
		}
		break;

		case e_U_child:
		{
			if(!m_pRGBparent)break;

			s_ParentsOnlyParams& m_Params=m_pRGBparent->m_Params;//   
			if(!m_Params.CheckCorrectForParentBody())break;// 

			// DIB
			BYTE* pDIB=m_Params.ZeroAndThenGetPointer_m_TempBuferToMakeDIB();
			def_MakeDIB_beg(pDIB,m_Params.Get_m_LastUsedBitzDataLen(),m_Params.Get_m_dwdX(),m_Params.Get_m_dwdY(),break);
			def_MakeDIB_end(pDIB,m_Params.Get_m_pUpixel(x,y,true)->RGBpixel);
			def_OutDIBtoScreen;// DIB  
		}
		break;

		case e_V_child:
		{
			if(!m_pRGBparent)break;

			s_ParentsOnlyParams& m_Params=m_pRGBparent->m_Params;//   
			if(!m_Params.CheckCorrectForParentBody())break;// 

			// DIB
			BYTE* pDIB=m_Params.ZeroAndThenGetPointer_m_TempBuferToMakeDIB();
			def_MakeDIB_beg(pDIB,m_Params.Get_m_LastUsedBitzDataLen(),m_Params.Get_m_dwdX(),m_Params.Get_m_dwdY(),break);
			def_MakeDIB_end(pDIB,m_Params.Get_m_pVpixel(x,y,true)->RGBpixel);
			def_OutDIBtoScreen;// DIB  
		}
		break;

		case e_RGB_srcShow:
		{
			if(!m_pRGBparent)break;

			//   
			s_ParentsOnlyParams& m_Params=m_pRGBparent->m_Params;
			if(!m_Params.CheckCorrectForParentBody())break;

			// DIB
			BYTE* pDIB=m_Params.ZeroAndThenGetPointer_m_TempBuferToMakeDIB();
			def_MakeDIB_beg(pDIB,m_Params.Get_m_LastUsedBitzDataLen(),m_Params.Get_m_dwdX(),m_Params.Get_m_dwdY(),break);
			def_MakeDIB_end(pDIB,m_Params.Get_m_pRGBpixel(x,y,true)->RGBsrc);
			def_OutDIBtoScreen;// DIB  
		}
		break;

	}
	#undef def_OutDIBtoScreen
}


//   ,         BMP
bool CBitmapBuffer::CreateNewFromBitmapFileArray(const BYTE *pFile_in, const DWORD dwdFileLen_in,CString* pcsErrorReport)
{
	//    (  )
	if(pcsErrorReport)*pcsErrorReport="";

	Clear(true);

	if(m_Mode!=e_RGB_parent)return false;

	const BYTE* pMaxAddress_nzb=pFile_in+dwdFileLen_in;
	const BYTE* pCurrAddress=pFile_in;
	const BYTE* pGrafData=0;

	//  

	if(pcsErrorReport)*pcsErrorReport="  ";

	//  
	if(dwdFileLen_in<sizeof(DWORD))return false;
	//  4        
	switch(*(DWORD*)pFile_in)
	{
		default:
		{
			if( (*(WORD*)pFile_in) == ('M'<<8 | 'B') )
			{
				//   BITMAPFILEHEADER
			}
			else
			{
				// 
				return false;
			}

			// BITMAPFILEHEADER
			BITMAPFILEHEADER bmpHdr;
			if(pCurrAddress+sizeof(bmpHdr)>=pMaxAddress_nzb)return false;
			bmpHdr=*(BITMAPFILEHEADER*)pCurrAddress;
			m_Params.m_LastUsedBITMAPFILEHEADER=bmpHdr;
			pCurrAddress+=sizeof(bmpHdr);

			// 
			if(bmpHdr.bfType!=('M'<<8 | 'B'))return false;
			if(bmpHdr.bfSize!=dwdFileLen_in)return false;
			if(bmpHdr.bfReserved1!=0)return false;
			if(bmpHdr.bfReserved2!=0)return false;

			pGrafData=pFile_in+bmpHdr.bfOffBits;
			if(pGrafData>=pMaxAddress_nzb)return false;

			BITMAPINFOHEADER bmpInfo;
			if(pCurrAddress+sizeof(bmpInfo)>=pMaxAddress_nzb)return false;
			bmpInfo=*(BITMAPINFOHEADER*)pCurrAddress;
			m_Params.m_LastUsedBITMAPINFOHEADER=bmpInfo;
			pCurrAddress+=sizeof(bmpInfo);

			DWORD dwdX=0;
			DWORD dwdY=0;
			WORD wBitzOnPix=0;
			DWORD dwdColorsCount=0;
			{
				if(bmpInfo.biSize!=sizeof(bmpInfo))return false;
				dwdX=bmpInfo.biWidth;
				dwdY=bmpInfo.biHeight;
				if(!dwdX || !dwdY)return false;
				if(bmpInfo.biPlanes!=1)return false;
				wBitzOnPix=bmpInfo.biBitCount;
				dwdColorsCount=bmpInfo.biClrUsed;


				if(bmpInfo.biCompression!=BI_RGB)
				{
					if(pcsErrorReport)*pcsErrorReport=" ,     ";
					return false;
				}
			}

			switch(wBitzOnPix)
			{
				default:
				{
					return false;
				}

				case 8:
				{
					//

					const RGBQUAD* pPalette=0;
					if(pCurrAddress+sizeof(RGBQUAD)*256>=pMaxAddress_nzb)return false;
					pPalette=(const RGBQUAD*)pCurrAddress;
					pCurrAddress+=sizeof(RGBQUAD)*256;

					if(pGrafData!=pCurrAddress)return false;

					if(pcsErrorReport)*pcsErrorReport=" ,      ";

					//  
					//...

					return false;
				}
				break;

				case 24:
				{
					if(pGrafData!=pCurrAddress)return false;

					DWORD dwdDataLen=pMaxAddress_nzb-pGrafData;

					//     4,       
					if(dwdX*dwdY*3+(dwdX%4*dwdY)!=dwdDataLen)return false;

					if(!m_Params.CreateNewAndGetPointer_m_TempBuferToMakeDIB(dwdDataLen))
					{
						if(pcsErrorReport)*pcsErrorReport="     ";
						Clear(true);
						return false;
					}

					if(!m_Params.CreateNew_m_pBMP(dwdX,dwdY))
					{
						if(pcsErrorReport)*pcsErrorReport="     ";
						Clear(true);
						return false;
					}

					// m_pRGB  DIB
					DWORD x;
					DWORD y;
					for(y=0;y<m_Params.Get_m_dwdY();y++)
					{
						for(x=0;x<m_Params.Get_m_dwdX();x++)
						{
							//,    
							//s_RGBelement* pCurrPix=&m_pRGB[(m_Params.Get_m_dwdY()-y-1)*m_Params.Get_m_dwdX()+x];
							s_RGBelement* pCurrPix=m_Params.Get_m_pRGBpixel(x,y,true);

							pCurrPix->RGBsrc=0;
							*(2+(BYTE*)&pCurrPix->RGBsrc)=*pGrafData; pGrafData++;
							*(1+(BYTE*)&pCurrPix->RGBsrc)=*pGrafData; pGrafData++;
							*(0+(BYTE*)&pCurrPix->RGBsrc)=*pGrafData; pGrafData++;
						}

						//   4 (   )
						pGrafData+=(x%4);
					}

					//  Y,U  V
					m_Params.Refresh_YUV_AfterRGBjustFilled(m_Mode,m_Params.m_bAjustModeRGB,true);
				}
				break;
			}
		}
		break;

		//  BITMAPV4HEADER
		case sizeof(BITMAPV4HEADER):
		{
			if(pcsErrorReport)*pcsErrorReport=" BITMAPV4HEADER ,     ";
			//  
			//...
			return false;
		}
		break;

		/*
		//  BITMAPV5HEADER
		case sizeof(BITMAPV5HEADER):
		{
			if(pcsErrorReport)*pcsErrorReport=" BITMAPV5HEADER ,     ";
			//  
			//...
			return false;
		}
		break;
		*/
	}

	//   RGB
	m_Params.m_bAjustModeRGB=false;

	//  "   " ( CBmpWorkDlg::OnPaint())
	m_Params.m_bFileJustLoaded=true;

	return true;
}

//  Y,U  V ,    
void CBitmapBuffer::Refresh_YUV_AfterRatioChanged()
{
	if(m_Mode!=e_RGB_parent)return;

	m_Params.m_byYratio=min(e_percent_max,m_Params.m_byYratio);
	m_Params.m_byUratio=min(e_percent_max,m_Params.m_byUratio);
	m_Params.m_byVratio=min(e_percent_max,m_Params.m_byVratio);

	m_Params.Refresh_YUV_AfterRGBjustFilled(m_Mode,m_Params.m_bAjustModeRGB,false);
}

//    -      
bool CBitmapBuffer::PrepareFileToSave(s_TempBuff* pBuff,CString* pcsErrorReport)
{
	if(pcsErrorReport)*pcsErrorReport=" ";

	if(m_Mode!=e_RGB_parent)return false;

	if(!m_Params.CheckCorrectForParentBody())return false;

	// 
	DWORD dwdNeedSize=0;

	dwdNeedSize+=sizeof(BITMAPFILEHEADER);
	dwdNeedSize+=sizeof(BITMAPINFOHEADER);
	dwdNeedSize+=m_Params.Get_m_LastUsedBitzDataLen();

	if(pcsErrorReport)*pcsErrorReport="      ";
	if(!pBuff->CreateBuffOnce(dwdNeedSize))return false;
	memset(pBuff->GetBuff(),0,pBuff->GetLen());

	BYTE* pCurrAddress=pBuff->GetBuff();

	*((BITMAPFILEHEADER*)pCurrAddress)=m_Params.m_LastUsedBITMAPFILEHEADER;
	pCurrAddress+=sizeof(m_Params.m_LastUsedBITMAPFILEHEADER);

	*((BITMAPINFOHEADER*)pCurrAddress)=m_Params.m_LastUsedBITMAPINFOHEADER;
	pCurrAddress+=sizeof(m_Params.m_LastUsedBITMAPINFOHEADER);

	BYTE* pGrafData=pCurrAddress;

	DWORD x;
	DWORD y;
	for(y=0;y<m_Params.Get_m_dwdY();y++)
	{
		for(x=0;x<m_Params.Get_m_dwdX();x++)
		{
			//,     (true)
			const s_RGBelement* pCurrPix=m_Params.Get_m_pRGBpixel(x,y,true);

			*pGrafData=*(2+(BYTE*)&pCurrPix->RGBnew); pGrafData++;
			*pGrafData=*(1+(BYTE*)&pCurrPix->RGBnew); pGrafData++;
			*pGrafData=*(0+(BYTE*)&pCurrPix->RGBnew); pGrafData++;
		}

		//  4
		pGrafData+=(x%4);
	}

	return true;
}

//    
CString CBitmapBuffer::GetMatrixLikeString()
{
	CString csResult="";
	CString txt;
	DWORD x0=0;
	DWORD y0=0;

	DWORD x=0;
	DWORD y=0;

	//   256     
	CString a_csConv[256];
	for(DWORD dwd=0;dwd<256;dwd++)
	{
		a_csConv[dwd].Format("%02X,",dwd);
	}

	DWORD dwdXmaxToOut=10;
	DWORD dwdYmaxToOut=20;

	switch(m_Mode)
	{
		case e_RGB_parent:
		{
			if(m_pRGBparent)break;

			if(!m_Params.CheckCorrectForParentBody())break;
			for(y=0;y<m_Params.Get_m_dwdY();y++)
			{
				txt.Format("%03d:",y);
				csResult+=txt;
				for(x=0;x<m_Params.Get_m_dwdX();x++)
				{
					//DWORD rgb=m_pRGB[y*m_Params.Get_m_dwdX()+x].RGBnew;
					DWORD rgb=m_Params.Get_m_pRGBpixel(x,y)->RGBnew;

					txt.Format("%s%s%s|",a_csConv[*(0+(BYTE*)&rgb)],a_csConv[*(1+(BYTE*)&rgb)],a_csConv[*(2+(BYTE*)&rgb)]);
					csResult+=txt;
					if(x>=dwdXmaxToOut)
					{
						csResult+="...";
						break;
					}
				}
				csResult+="\r\n";
				if(y>=dwdYmaxToOut)
				{
					csResult+="...\r\n";
					csResult+="...\r\n";
					break;
				}
			}
		}
		break;

		case e_Y_child:
		case e_U_child:
		case e_V_child:
		{
			s_YUVelement* pCurrPix=0;

			if(!m_pRGBparent)break;

			//   
			s_ParentsOnlyParams& m_Params=m_pRGBparent->m_Params;

			if(!m_Params.CheckCorrectForParentBody())break;

			switch(m_Mode)
			{
				case e_Y_child:pCurrPix=m_Params.Get_m_pY();break;
				case e_U_child:pCurrPix=m_Params.Get_m_pU();break;
				case e_V_child:pCurrPix=m_Params.Get_m_pV();break;
			}

			for(y=0;y<m_Params.Get_m_dwdY();y++)
			{
				txt.Format("%03d:",y);
				csResult+=txt;
				for(x=0;x<m_Params.Get_m_dwdX();x++)
				{

					BYTE Xpart=0;
					
					if(m_Params.m_bAjustModeRGB)
					{
						Xpart=(BYTE)pCurrPix[y*m_Params.Get_m_dwdX()+x].Xpart;
					}
					else
					{
						Xpart=(BYTE)pCurrPix[y*m_Params.Get_m_dwdX()+x].Xpart;
					}
					

					txt.Format("%s|",a_csConv[Xpart]);
					csResult+=txt;
					if(x>=dwdXmaxToOut)
					{
						csResult+="...";
						break;
					}
				}
				csResult+="\r\n";
				if(y>=dwdYmaxToOut)
				{
					csResult+="...\r\n";
					csResult+="...\r\n";
					break;
				}
			}
		}
		break;

		case e_RGB_srcShow:
		{
			if(!m_pRGBparent)break;

			//   
			s_ParentsOnlyParams& m_Params=m_pRGBparent->m_Params;

			if(!m_Params.CheckCorrectForParentBody())break;

			for(y=0;y<m_Params.Get_m_dwdY();y++)
			{
				txt.Format("%03d:",y);
				csResult+=txt;
				for(x=0;x<m_Params.Get_m_dwdX();x++)
				{
					DWORD rgb=m_Params.Get_m_pRGBpixel(x,y)->RGBsrc;

					txt.Format("%s%s%s|",	a_csConv[*(0+(BYTE*)&rgb)],
											a_csConv[*(1+(BYTE*)&rgb)],
											a_csConv[*(2+(BYTE*)&rgb)]);
					csResult+=txt;
					if(x>=dwdXmaxToOut)
					{
						csResult+="...";
						break;
					}
				}
				csResult+="\r\n";
				if(y>=dwdYmaxToOut)
				{
					csResult+="...\r\n";
					csResult+="...\r\n";
					break;
				}
			}
		}
		break;

	}


	return csResult;
}

ee_mode CBitmapBuffer::GetMode()
{
	return m_Mode;
}