// BitmapBuffer.h: interface for the CBitmapBuffer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BITMAPBUFFER_H__DA0827B9_3C69_4F84_8850_4AC38F475D81__INCLUDED_)
#define AFX_BITMAPBUFFER_H__DA0827B9_3C69_4F84_8850_4AC38F475D81__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "UsualIncludes1153_bmpwork.h"

//------------------------
class CBitmapBuffer;//      s_ParentsOnlyParams
//------------------------

// 
enum
{
	e_percent_min	=	0,		//0...
	e_percent_def	=	100,	//e_percent_min<=e_percent_def<=e_percent_max
	e_percent_max	=	200,	//e_percent_def...255
	
};
//------------------------
//  CBitmapBuffer
enum ee_mode
{
	e_0 = 0,			//  
	e_RGB_parent,		// RGB -  (  ) (  -  )
	e_Y_child,			//  Y 			(  - Y )
	e_U_child,			//  U 			(  - U )
	e_V_child,			//  V 			(  - V )
	e_RGB_srcShow,		// RGB -  				(  -  )
};
//------------------------
// Y,U  V
struct s_YUVelement
{
	DWORD RGBpixel;	//     ()
	double Xpart;	//  Y, U  V
};
//------------------------
// RGB
struct s_RGBelement
{
	DWORD RGBsrc;	// 
	DWORD RGBnew;	// 
};
//------------------------

//  ,     "" ,
//       
struct s_ParentsOnlyParams
{

private:
	//    [m_dwdX*m_dwdY]
	s_RGBelement* m_pRGB;	// RGB
	s_YUVelement* m_pY;		// Y
	s_YUVelement* m_pU;		// U
	s_YUVelement* m_pV;		// V
	DWORD m_dwdX;			// 
	DWORD m_dwdY;			// 
	//------
	BYTE* m_TempBuferToMakeDIB;		//   DIB     
	DWORD m_LastUsedBitzDataLen;	//  :  DIB   
	//(DIB -    , .  BMP)


public:
	BITMAPFILEHEADER m_LastUsedBITMAPFILEHEADER;//  :  BITMAPFILEHEADER  
	BITMAPINFOHEADER m_LastUsedBITMAPINFOHEADER;//  :  BITMAPINFOHEADER  

	bool m_bFileJustLoaded;	//    - "   " ( CBmpWorkDlg::OnPaint() )
	bool m_bAjustModeRGB;	//  RGB 
	BYTE m_byYratio;//%   Y
	BYTE m_byUratio;//%   U
	BYTE m_byVratio;//%   V

	s_ParentsOnlyParams()
	{
		//     
		m_TempBuferToMakeDIB=0;
		m_pRGB=0;
		m_pY=0;
		m_pU=0;
		m_pV=0;

		Clear();
	}

	void Clear()
	{
		if(m_TempBuferToMakeDIB)delete [] m_TempBuferToMakeDIB;
		if(m_pRGB)delete [] m_pRGB;
		if(m_pY)delete [] m_pY;
		if(m_pU)delete [] m_pU;
		if(m_pV)delete [] m_pV;

		memset(this,0,sizeof(*this));

		m_byYratio=e_percent_def;
		m_byUratio=e_percent_def;
		m_byVratio=e_percent_def;

	}

	void SetRatiosInPersentsOf0to200(BYTE Yratio,BYTE Uratio,BYTE Vratio)
	{
		m_byYratio=min(e_percent_max,Yratio);
		m_byUratio=min(e_percent_max,Uratio);
		m_byVratio=min(e_percent_max,Vratio);
	}

	//        
	bool SetMode(ee_mode mode_in,CBitmapBuffer* pParentWatcher)
	{
		switch(mode_in)
		{
			default:return false;

			case e_RGB_parent:
			{
				if(pParentWatcher)return false;
			}
			break;

			case e_Y_child:
			case e_U_child:
			case e_V_child:
			case e_RGB_srcShow:
			{
				if(!pParentWatcher)return false;
			}
			break;
		}

		return true;
	}

	//    DIB     
	inline BYTE* CreateNewAndGetPointer_m_TempBuferToMakeDIB(DWORD dwdDadaLen)
	{
		m_LastUsedBitzDataLen=dwdDadaLen;
		m_TempBuferToMakeDIB=new BYTE[m_LastUsedBitzDataLen];
		return m_TempBuferToMakeDIB;
	}

	//    DIB     
	inline BYTE* ZeroAndThenGetPointer_m_TempBuferToMakeDIB()
	{
		if(!m_TempBuferToMakeDIB)return 0;
		memset(m_TempBuferToMakeDIB,0,m_LastUsedBitzDataLen);
		return m_TempBuferToMakeDIB;
	}

	inline DWORD Get_m_LastUsedBitzDataLen()
	{
		return m_LastUsedBitzDataLen;
	}

	inline BYTE* Get_m_TempBuferToMakeDIB()
	{
		return m_TempBuferToMakeDIB;
	}


	inline DWORD Get_m_dwdY() {return m_dwdY;}
	inline DWORD Get_m_dwdX() {return m_dwdX;}

	//    !!!
	inline s_RGBelement* Get_m_pRGBpixel(DWORD x,DWORD y,bool bForDIB=false)
	{
		return &m_pRGB[(bForDIB?(m_dwdY-y-1):y)*m_dwdX+x];
	}

	//    !!!
	inline s_YUVelement* Get_m_pYpixel(DWORD x,DWORD y,bool bForDIB=false){return &m_pY[(bForDIB?(m_dwdY-y-1):y)*m_dwdX+x];}
	inline s_YUVelement* Get_m_pUpixel(DWORD x,DWORD y,bool bForDIB=false){return &m_pU[(bForDIB?(m_dwdY-y-1):y)*m_dwdX+x];}
	inline s_YUVelement* Get_m_pVpixel(DWORD x,DWORD y,bool bForDIB=false){return &m_pV[(bForDIB?(m_dwdY-y-1):y)*m_dwdX+x];}

	inline s_YUVelement* Get_m_pY(){return m_pY;}
	inline s_YUVelement* Get_m_pU(){return m_pU;}
	inline s_YUVelement* Get_m_pV(){return m_pV;}

	//    !!!
	bool CreateNew_m_pBMP(DWORD dwdx,DWORD dwdy)
	{
		m_pRGB=new s_RGBelement[dwdx*dwdy];
		if(!m_pRGB)return false;
		m_dwdX=dwdx;
		m_dwdY=dwdy;
		return true;
	}

	//  YUV    RGB
	void Refresh_YUV_AfterRGBjustFilled(ee_mode CurrMode,bool bAjustModeRGB,bool bNew)
	{
		if(CurrMode!=e_RGB_parent)return;

		if(!m_pRGB)return;
		if(!m_dwdX || !m_dwdY)return;

		QWORD qwCount=m_dwdX*m_dwdY;

		if(qwCount>0xffffffff)return;

		if(bNew)
		{
			if(!m_pY || !m_pU || !m_pV)
			{
				if(m_pY)delete[]m_pY;
				if(m_pU)delete[]m_pU;
				if(m_pV)delete[]m_pV;

				m_pY=new s_YUVelement [(DWORD)qwCount];
				m_pU=new s_YUVelement [(DWORD)qwCount];
				m_pV=new s_YUVelement [(DWORD)qwCount];
			}
		}

		if(!m_pY || !m_pU || !m_pV)return;

		double Y=0;
		double U=0;
		double V=0;

		double dYr=((double)m_byYratio)/100;
		double dUr=((double)m_byUratio)/100;
		double dVr=((double)m_byVratio)/100;

		DWORD dwdInd;

		for(dwdInd=0;dwdInd<(DWORD)qwCount;dwdInd++)
		{
			GetYUVfromRGB(bAjustModeRGB,m_pRGB[dwdInd].RGBsrc,Y,U,V);

			m_pY[dwdInd].Xpart=Y;
			m_pY[dwdInd].RGBpixel=GetRGBfromYUV(bAjustModeRGB,Y*dYr,0,0);

			m_pU[dwdInd].Xpart=U;
			m_pU[dwdInd].RGBpixel=GetRGBfromYUV(bAjustModeRGB,0,U*dUr,0);

			m_pV[dwdInd].Xpart=V;
			m_pV[dwdInd].RGBpixel=GetRGBfromYUV(bAjustModeRGB,0,0,V*dVr);
		}

		for(dwdInd=0;dwdInd<(DWORD)qwCount;dwdInd++)
		{
			m_pRGB[dwdInd].RGBnew=GetRGBfromYUV(
					bAjustModeRGB,
					((double)m_pY[dwdInd].Xpart)*dYr,
					((double)m_pU[dwdInd].Xpart)*dUr,
					((double)m_pV[dwdInd].Xpart)*dVr
					);
		}

	}

	//   RGB  YUV
	inline void GetYUVfromRGB(bool bAjustModeRGB,DWORD rgb,double& Y,double& U,double& V)
	{
		if(bAjustModeRGB)
		{
			double r=*(0+(BYTE*)&rgb);
			double g=*(1+(BYTE*)&rgb);
			double b=*(2+(BYTE*)&rgb);
			Y = r;
			U = g;
			V = b;
		}
		else
		{
			double r=((double)*(0+(BYTE*)&rgb));
			double g=((double)*(1+(BYTE*)&rgb));
			double b=((double)*(2+(BYTE*)&rgb));

			double Wr=0.299;
			double Wg=0.587;
			double Wb=0.114;

			Y = Wr*r + Wg*g + Wb*b;
			U = 0.436*(b-Y)/(1-Wb);
			V = 0.615*(r-Y)/(1-Wr);
		}
	}

	//   YUV  RGB
	inline DWORD GetRGBfromYUV(bool bAjustModeRGB,double Y,double U,double V)
	{
		DWORD rgb=0;

		if(bAjustModeRGB)
		{
			*(0+(BYTE*)&rgb)=(BYTE)max(0,min(255,Y));	//r
			*(1+(BYTE*)&rgb)=(BYTE)max(0,min(255,U));	//g
			*(2+(BYTE*)&rgb)=(BYTE)max(0,min(255,V));	//b
		}
		else
		{
			*(0+(BYTE*)&rgb)=(BYTE) max(0,min(255,	Y+V*1.13983				));	//r
			*(1+(BYTE*)&rgb)=(BYTE) max(0,min(255,	Y-U*0.39465-V*0.58060	));	//g
			*(2+(BYTE*)&rgb)=(BYTE) max(0,min(255,	Y+U*2.03211				));	//b
		}

		return rgb;
	}

	//    
	inline bool CheckCorrectForParentBody()
	{
		if( !m_pRGB || !m_pY || !m_pU || !m_pV || !m_dwdX || !m_dwdY )return false;
		return true;
	}

};

//------------------------

class CBitmapBuffer
{
private:
	//////////////////////////////////////////////
	//    ..._child
	CBitmapBuffer* m_pRGBparent;

	//  
	ee_mode m_Mode;

public:

	//      
	s_ParentsOnlyParams m_Params;

public:
	CString GetMatrixLikeString();
	bool PrepareFileToSave(s_TempBuff* pBuff,CString* pcsErrorReport=0);
	void Refresh_YUV_AfterRatioChanged();
	void Paint_OnDc(CDC &dc, long ldcW, long ldcH,long xScrollShift,long yScrollShift);

	bool SetMode(ee_mode mode_in,CBitmapBuffer* pParentWatcher=0);
	ee_mode GetMode();

	CBitmapBuffer();
	virtual ~CBitmapBuffer();
	void Clear(bool bDontTouchModeAndParentPointer=false);

	bool CreateNewFromBitmapFileArray(const BYTE* pFile_in, const DWORD dwdFileLen_in,CString* pcsErrorReport=0);

};

#endif // !defined(AFX_BITMAPBUFFER_H__DA0827B9_3C69_4F84_8850_4AC38F475D81__INCLUDED_)
