// BmpWorkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BmpWork.h"
#include "BmpWorkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBmpWorkDlg dialog

CBmpWorkDlg::CBmpWorkDlg(CWnd* pParent)	: CDialog(CBmpWorkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBmpWorkDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBmpWorkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBmpWorkDlg)
	DDX_Control(pDX, IDC_RGBsrc, m_IDC_RGBsrc);
	DDX_Control(pDX, IDC_V, m_IDC_V);
	DDX_Control(pDX, IDC_U, m_IDC_U);
	DDX_Control(pDX, IDC_Y, m_IDC_Y);
	DDX_Control(pDX, IDC_RGBnew_main, m_IDC_RGBnew_main);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBmpWorkDlg, CDialog)
	//{{AFX_MSG_MAP(CBmpWorkDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_chkRGBajust, OnchkRGBajust)
	ON_BN_CLICKED(IDC_bnSave, OnbnSave)
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_bnResetAll, OnbnResetAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBmpWorkDlg message handlers

extern CBmpWorkApp theApp;

BOOL CBmpWorkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, FALSE);		// Set small icon
	SetIcon(m_hIcon, TRUE);			// Set big icon

	MakeCaptionText();


	m_IDC_RGBnew_main.m_Bitmap.SetMode(	e_RGB_parent);

	m_IDC_Y.m_Bitmap.SetMode(	e_Y_child,&m_IDC_RGBnew_main.m_Bitmap);
	m_IDC_U.m_Bitmap.SetMode(	e_U_child,&m_IDC_RGBnew_main.m_Bitmap);
	m_IDC_V.m_Bitmap.SetMode(	e_V_child,&m_IDC_RGBnew_main.m_Bitmap);
	m_IDC_RGBsrc.m_Bitmap.SetMode(	e_RGB_srcShow,&m_IDC_RGBnew_main.m_Bitmap);


	//      
	CString txt=theApp.m_lpCmdLine;
	if(txt.GetLength()>0)
	{
		//   
		txt=txt.Mid(1);
		txt=txt.SpanExcluding("\"");

		// 
		OpenTheFileInDialog(txt);
	}

	//  
	((CSliderCtrl*)GetDlgItem(IDC_slY))->SetRange(e_percent_min,e_percent_max,1);
	((CSliderCtrl*)GetDlgItem(IDC_slU))->SetRange(e_percent_min,e_percent_max,1);
	((CSliderCtrl*)GetDlgItem(IDC_slV))->SetRange(e_percent_min,e_percent_max,1);

	((CScrollBar*)GetDlgItem(IDC_barH))->SetScrollRange(0,100,1);
	((CScrollBar*)GetDlgItem(IDC_barV))->SetScrollRange(0,100,1);


	MakeCaptionText();


	SetTimer(1,150,0);



	ResetControlsWhenFileJustLoaded();

	return TRUE;
}


void CBmpWorkDlg::OnPaint() 
{
	CDialog::OnPaint();

	if(m_IDC_RGBnew_main.m_Bitmap.m_Params.m_bFileJustLoaded)
	{
		//   

		//  
		m_IDC_RGBnew_main.m_Bitmap.m_Params.m_bFileJustLoaded=false;

		//   
		ResetControlsWhenFileJustLoaded();
	}
}

HCURSOR CBmpWorkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBmpWorkDlg::OnOK(){}
void CBmpWorkDlg::OnCancel(){}

void CBmpWorkDlg::OnClose() 
{
	CDialog::OnCancel();
}

void CBmpWorkDlg::MakeCaptionText()
{
	SetWindowText(" BMP");
}

//     
void CBmpWorkDlg::OpenTheFileInDialog(const char *pFileFullPath_w_ext)
{
	m_IDC_RGBnew_main.OpenTheFile(pFileFullPath_w_ext);
}

// 
void CBmpWorkDlg::OnTimer(UINT nIDEvent)
{

	if(nIDEvent==1)
	{
		static int prevYratio=-1;
		static int prevUratio=-1;
		static int prevVratio=-1;

		// -     ?
		int newYratio=e_percent_max-((CSliderCtrl*)GetDlgItem(IDC_slY))->GetPos();
		int newUratio=e_percent_max-((CSliderCtrl*)GetDlgItem(IDC_slU))->GetPos();
		int newVratio=e_percent_max-((CSliderCtrl*)GetDlgItem(IDC_slV))->GetPos();

		if(prevYratio!=newYratio || prevUratio!=newUratio || prevVratio!=newVratio)
		{
			//

			prevYratio=newYratio;
			prevUratio=newUratio;
			prevVratio=newVratio;

			CString txt;

			// 
			txt.Format("%d",newYratio);	GetDlgItem(IDC_stCurrYRPersent)->SetWindowText(txt);
			txt.Format("%d",newUratio);	GetDlgItem(IDC_stCurrUGPersent)->SetWindowText(txt);
			txt.Format("%d",newVratio);	GetDlgItem(IDC_stCurrVBPersent)->SetWindowText(txt);

			//  
			m_IDC_RGBnew_main.m_Bitmap.m_Params.SetRatiosInPersentsOf0to200(newYratio,newUratio,newVratio);

			// 
			m_IDC_RGBnew_main.m_Bitmap.Refresh_YUV_AfterRatioChanged();

			Invalidate(0);
		}


	}
	
	CDialog::OnTimer(nIDEvent);
}


//   RGB 
void CBmpWorkDlg::OnchkRGBajust() 
{
	// 
	CorrectYUVRGBlabels();

	// 
	m_IDC_RGBnew_main.m_Bitmap.Refresh_YUV_AfterRatioChanged();

	Invalidate(0);
}

//   
void CBmpWorkDlg::OnbnSave() 
{
	s_TempBuff Buff;

	CString csErrorReport;
	if(!m_IDC_RGBnew_main.m_Bitmap.PrepareFileToSave(&Buff,&csErrorReport))
	{
		if(csErrorReport!="")
		{
			MessageBox(csErrorReport,0,MB_ICONASTERISK|MB_SYSTEMMODAL);
		}

		return;
	}

	//    ( ,    )
	CString csDefaultFolder;
	csDefaultFolder=m_IDC_RGBnew_main.m_csLastLoadedFile;
	if(csDefaultFolder!="")
	{
		csDefaultFolder.MakeReverse();
		csDefaultFolder=csDefaultFolder.Mid(csDefaultFolder.SpanExcluding("\\").GetLength());
		csDefaultFolder.MakeReverse();
	}


	CString csFileName;
	//  
	{
		CFileDialog dlg(0,0,0,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,0,this);

		dlg.m_ofn.lpstrDefExt="bmp";
		dlg.m_ofn.lpstrFilter=" bmp (*.bmp)\0*.bmp\0\0";
		dlg.m_ofn.nFilterIndex=1;
		dlg.m_ofn.lpstrInitialDir=csDefaultFolder;
		dlg.m_ofn.lpstrTitle=" ";

		if(dlg.DoModal()==IDOK)
		{
			csFileName=dlg.GetPathName();
		}
		else
		{
			csFileName="";
		}
	}

	if(csFileName=="")return;

	//  

	// 
	s_TempFileHandle FileHandle;


	FileHandle.hFile=CreateFile(csFileName,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
	if(!FileHandle.IsValid())
	{
		MessageBox("      ",0,MB_ICONEXCLAMATION|MB_SYSTEMMODAL);
		return;
	}

	DWORD dwdWritten=0;
	if(!WriteFile(FileHandle.hFile,Buff.GetBuff(),Buff.GetLen(),&dwdWritten,0) || Buff.GetLen()!=dwdWritten)
	{
		MessageBox("     ",0,MB_ICONHAND|MB_SYSTEMMODAL);
		return;
	}
	
	MessageBox(" ",0,MB_ICONASTERISK|MB_SYSTEMMODAL);
}

//   
void CBmpWorkDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int readPos;
	CScrollBar* pVbar=((CScrollBar*)GetDlgItem(IDC_barV));

	if(pVbar==pScrollBar)
	{
		readPos=pVbar->GetScrollPos();
		switch(nSBCode)
		{
			case SB_LINELEFT:		readPos-=1;	break;// 
			case SB_LINERIGHT:		readPos+=1;	break;// 
			case SB_PAGELEFT:		readPos-=10;break;// 
			case SB_PAGERIGHT:		readPos+=10;break;// 
			case SB_THUMBPOSITION:				break;//readPos=readPos;
			case SB_THUMBTRACK:		readPos=nPos;break;//  
			case SB_BOTTOM:						break;//readPos=readPos;
			case SB_ENDSCROLL:					break;//readPos=readPos;
		}
		pVbar->SetScrollPos(readPos);

		m_IDC_RGBnew_main	.m_nYscrollShiftOf100percent=readPos;
		m_IDC_RGBsrc		.m_nYscrollShiftOf100percent=readPos;
		m_IDC_Y				.m_nYscrollShiftOf100percent=readPos;
		m_IDC_U				.m_nYscrollShiftOf100percent=readPos;
		m_IDC_V				.m_nYscrollShiftOf100percent=readPos;

		Invalidate(0);
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

//   
void CBmpWorkDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int readPos;
	CScrollBar* pHbar=((CScrollBar*)GetDlgItem(IDC_barH));

	if(pHbar==pScrollBar)
	{
		readPos=pHbar->GetScrollPos();
		switch(nSBCode)
		{
			case SB_LINELEFT:		readPos-=1;	break;// 
			case SB_LINERIGHT:		readPos+=1;	break;// 
			case SB_PAGELEFT:		readPos-=10;break;// 
			case SB_PAGERIGHT:		readPos+=10;break;// 
			case SB_THUMBPOSITION:				break;//readPos=readPos;
			case SB_THUMBTRACK:		readPos=nPos;break;//  
			case SB_BOTTOM:						break;//readPos=readPos;
			case SB_ENDSCROLL:					break;//readPos=readPos;
		}
		pHbar->SetScrollPos(readPos);

		m_IDC_RGBnew_main	.m_nXscrollShiftOf100percent=readPos;
		m_IDC_RGBsrc		.m_nXscrollShiftOf100percent=readPos;
		m_IDC_Y				.m_nXscrollShiftOf100percent=readPos;
		m_IDC_U				.m_nXscrollShiftOf100percent=readPos;
		m_IDC_V				.m_nXscrollShiftOf100percent=readPos;

		Invalidate(0);
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


//    
void CBmpWorkDlg::CorrectYUVRGBlabels()
{
	if( ((CButton*)GetDlgItem(IDC_chkRGBajust))->GetCheck() )
	{
		m_IDC_RGBnew_main.m_Bitmap.m_Params.m_bAjustModeRGB=true;

		GetDlgItem(IDC_Ylabel)->SetWindowText("R");
		GetDlgItem(IDC_Ulabel)->SetWindowText("G");
		GetDlgItem(IDC_Vlabel)->SetWindowText("B");
		GetDlgItem(IDC_stYwin)->SetWindowText("R");
		GetDlgItem(IDC_stUwin)->SetWindowText("G");
		GetDlgItem(IDC_stVwin)->SetWindowText("B");
	}
	else
	{
		m_IDC_RGBnew_main.m_Bitmap.m_Params.m_bAjustModeRGB=false;

		GetDlgItem(IDC_Ylabel)->SetWindowText("Y");
		GetDlgItem(IDC_Ulabel)->SetWindowText("U");
		GetDlgItem(IDC_Vlabel)->SetWindowText("V");
		GetDlgItem(IDC_stYwin)->SetWindowText("Y");
		GetDlgItem(IDC_stUwin)->SetWindowText("U");
		GetDlgItem(IDC_stVwin)->SetWindowText("V");
	}
}

//  
void CBmpWorkDlg::OnbnResetAll() 
{
	// ,      
	//m_IDC_RGBnew_main.m_Bitmap.m_Params.m_bFileJustLoaded=true;	
	ResetControlsWhenFileJustLoaded();
	Invalidate(0);
}

//      
void CBmpWorkDlg::ResetControlsWhenFileJustLoaded()
{
	CString txt;
	txt.Format("%d",e_percent_def);
	GetDlgItem(IDC_stCurrYRPersent)->SetWindowText(txt);
	GetDlgItem(IDC_stCurrUGPersent)->SetWindowText(txt);
	GetDlgItem(IDC_stCurrVBPersent)->SetWindowText(txt);

	((CSliderCtrl*)GetDlgItem(IDC_slY))->SetPos(e_percent_max-e_percent_def);
	((CSliderCtrl*)GetDlgItem(IDC_slU))->SetPos(e_percent_max-e_percent_def);
	((CSliderCtrl*)GetDlgItem(IDC_slV))->SetPos(e_percent_max-e_percent_def);

	m_IDC_RGBnew_main.m_Bitmap.m_Params.SetRatiosInPersentsOf0to200(e_percent_def,e_percent_def,e_percent_def);

	((CButton*)GetDlgItem(IDC_chkRGBajust))->SetCheck(0);
	
	((CScrollBar*)GetDlgItem(IDC_barH))->SetScrollPos(0);
	((CScrollBar*)GetDlgItem(IDC_barV))->SetScrollPos(0);
	m_IDC_RGBnew_main	.m_nYscrollShiftOf100percent=0;
	m_IDC_RGBsrc		.m_nYscrollShiftOf100percent=0;
	m_IDC_Y				.m_nYscrollShiftOf100percent=0;
	m_IDC_U				.m_nYscrollShiftOf100percent=0;
	m_IDC_V				.m_nYscrollShiftOf100percent=0;
	m_IDC_RGBnew_main	.m_nXscrollShiftOf100percent=0;
	m_IDC_RGBsrc		.m_nXscrollShiftOf100percent=0;
	m_IDC_Y				.m_nXscrollShiftOf100percent=0;
	m_IDC_U				.m_nXscrollShiftOf100percent=0;
	m_IDC_V				.m_nXscrollShiftOf100percent=0;

	CorrectYUVRGBlabels();
}
