//#include "UsualIncludes1153_bmpwork.h"

#pragma once

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


typedef unsigned __int64 QWORD;


/////////////////////////////////////////////////

#define _sysgreycolor (::GetSysColor(COLOR_3DFACE)) //""  



//   
//  ,   .
//   ,     
//   , -   "*", 
// 
static bool st_IsFileExists(LPCSTR lpPathName)
{
	HANDLE file=0;

	WIN32_FIND_DATA w32fd;

	::memset(&w32fd,0,sizeof(w32fd));
	w32fd.ftCreationTime.dwHighDateTime=-1;
	w32fd.ftLastAccessTime.dwHighDateTime=-1;
	w32fd.ftLastWriteTime.dwHighDateTime=-1;
	w32fd.nFileSizeHigh=-1;
	w32fd.nFileSizeLow=-1;

	file=::FindFirstFile(lpPathName,&w32fd);
	if(file==INVALID_HANDLE_VALUE || file==0)
	{	
		//  
		return false;
	}

	// 
	::FindClose(file);

	//   
	//if(res)*res=w32fd.cFileName;

	return true;
}


//   
struct s_TempBuff
{
	private:
	BYTE* m_pBuf;
	DWORD m_dwdLen;

	public:

	s_TempBuff(const DWORD dwdLen)
	{
		memset(this,0,sizeof(*this));
		CreateBuffOnce(dwdLen);
	}

	s_TempBuff()
	{
		memset(this,0,sizeof(*this));
	}

	bool CreateBuffOnce(const DWORD dwdLen)
	{
		if(m_pBuf) return false;

		if(!dwdLen)return false;

		m_pBuf=new BYTE[dwdLen];

		if(!m_pBuf)return false;

		m_dwdLen=dwdLen;
		return true;
	}

	inline BYTE* GetBuff()
	{
		return m_pBuf;
	}

	inline DWORD GetLen()
	{
		return m_dwdLen;
	}

	~s_TempBuff()
	{
		if(m_pBuf)
		{
			delete [] m_pBuf;
			m_pBuf=0;
		}
	}
};

//   
static void st_GetSystemPATH__(CString& CString_result)
{
	CString_result="";
	int len=MAX_PATH+1;
	char* chSys=new char[len];
	::memset(chSys,0,len);
	if(!::GetSystemDirectory(chSys,len))return;
	CString_result=chSys;
	CString_result+="\\";
	delete [] chSys;
	chSys=0;
}

//   
static void st_GetCurrentFolderPATH__(CString& CString_result)
{
	CString_result="";
	int len=MAX_PATH+1;
	char* chCurrPath=new char[len];
	::memset(chCurrPath,0,len);
	if(!::GetCurrentDirectory(len,chCurrPath))return;
	CString_result=chCurrPath;
	CString_result+="\\";
	delete [] chCurrPath;
	chCurrPath=0;
}

//   
#define def_ConstructFullExeName(CString_variable) \
	{\
		def_check_type(CString,CString_variable);\
		CString csAppName=GetCommandLine();\
		csAppName.Delete(0,1);\
		csAppName.Replace('\"','\0');\
		(CString_variable)=(const char*)csAppName;\
	}

//     
#define def_ConstructExeNameWithoutExt(CString_variable) \
	{\
		def_check_type(CString,CString_variable);\
		(CString_variable)=m_pszAppName;\
	}

//    __   
#define def_ConstructPathToExeName__(CString_variable) \
	{\
		def_ConstructFullExeName(CString_variable);\
		(CString_variable).MakeReverse();\
		(CString_variable)=(CString_variable).Mid( (CString_variable).SpanExcluding("\\").GetLength() );\
		(CString_variable).MakeReverse();\
	}

#define def_HandleIsInvalid(h) ((bool)(h==0 || h==INVALID_HANDLE_VALUE ))

// !!!!!!!
//GetProcessByExeName


//  
//  OnPaint().
//CPaintDC__context - -,    OnPaint ("CPaintDC dcReal(this);")
//PaintMethod -     "PaintGrid(CDC& dc, long ldcW, long ldcH)"
//  forceWid,forceHIG !=0 ,      ,       
//(     )
#define def_PaintWithNoBlink(CPaintDC__context,PaintMethod_refCPaintDC_long_long/*,forceWid,forceHIG*/) \
	{\
		/*   */\
		CRect PlotterRect;\
		long ldcW,ldcH;\
		\
		CRect winrect;\
		GetClientRect(&winrect);\
		\
		PlotterRect=winrect;\
		ldcW=PlotterRect.Width();\
		ldcH=PlotterRect.Height();\
		if(ldcW<0)ldcW=0;\
		if(ldcH<0)ldcH=0;\
		\
		/*    */\
		CDC dcPlotter;\
		CBitmap bmpMem;\
		\
		dcPlotter.CreateCompatibleDC(&CPaintDC__context);\
		bmpMem.CreateCompatibleBitmap(&CPaintDC__context,ldcW,ldcH);\
		\
		/*    */\
		CBitmap *oldbmpMem=dcPlotter.SelectObject(&bmpMem);\
		\
		/*   */\
		PaintMethod_refCPaintDC_long_long(dcPlotter,ldcW,ldcH);\
		\
		/*   (dcPlotter)   (CPaintDC__context)*/\
		(CPaintDC__context).BitBlt(0,0,ldcW,ldcH,&dcPlotter,0,0,SRCCOPY);\
		\
		/*    */\
		dcPlotter.SelectObject(oldbmpMem);\
		bmpMem.DeleteObject();\
		ReleaseDC(&dcPlotter);\
	}

//   
struct s_TempFileHandle
{
	HANDLE hFile;

	s_TempFileHandle()
	{
		hFile=0;
	}

	~s_TempFileHandle()
	{
		if(IsValid())
		{
			CloseHandle(hFile);
			hFile=0;
		}
	}

	bool IsValid()
	{
		return !def_HandleIsInvalid(hFile);
	}
};
